/*
################################################################################
#                                                                              #
# AUTHOR           : Andrew Fleming                                            #
#                                                                              #
# CREATION DATE    : 11 Feb 2008                                               #
#                                                                              #
# SHORT DESCRIPTION: AES Encryption/decryption standalone Tool                 #
#                                                                              #

################################################################################
*/
#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#define NONE_LOGLVL		0
#define ERROR_LOGLVL	1
#define WARN_LOGLVL		2
#define INFO_LOGLVL		3
#define DEBUG_LOGLVL	4

const int EC_SUCCESS = 0;

const int EC_ENCRYPT_DECRYPT                 = 0x00000001;
const int EC_GCRYPT_LOAD_ERROR               = 0x00000002;
const int EC_UNKNOWN_MODE				     = 0x00000004;
const int EC_INPUTFILE_DOESNOTEXIST          = 0x00000008;
const int EC_OUTPUTFILE_ALREADY_EXISTS       = 0x00000010;
const int EC_INPUTFILE_NAME_MISSING			 = 0x00000020;
const int EC_OUTPUTFILE_NAME_MISSING		 = 0x00000040;
const int EC_MODE_MISSING				     = 0x00000080;

const int EC_KEY_MISSING					 = 0x00000100;
const int EC_INCORRECT_SIZE				     = 0x00000200;
const int EC_NO_CIPHER_SET                   = 0x00000400;

#define AES_STANDARD_NAME                    "AES"
#define DES_STANDARD_NAME                    "DES"


extern int logging;
extern int loadfuncs();
extern void unloadfuncs();
extern void setkey(char *key, int keysize=16);
extern void loadArgs(char ** argc, int argv);
extern char *readArgs( char *name);
#define MLOG( log_level ) \
   if ( log_level <= logging) \
	    	      fprintf(stderr, 

