/*
################################################################################
#                                                                              #
# AUTHOR           : Andrew Fleming                                            #
#                                                                              #
# CREATION DATE    : 11 Feb 2008                                               #
#                                                                              #
# SHORT DESCRIPTION: AES Encryption/decryption standalone Tool                 #
#                                                                              #

################################################################################
*/
#include "keyvalue.h"
#include <malloc.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "aescommon.h"
extern struct keyvalue *kvlist[];
extern int logging;
void loadArgs(char ** argc, int argv){

	int i;
	;
//	*retlist= (struct keyvalue *)malloc (sizeof(struct keyvalue *)*(argv-1));
	for (int j=0;j<argv-1;j++){
		kvlist[j]=(struct keyvalue *)malloc(sizeof(struct keyvalue));
		memset(kvlist[j], 0, sizeof(struct keyvalue));
	}

	for (i=1; i<argv;i++){
		if (strnicmp(argc[i], "/loglevel=",10)==0){
			int tmploglevel;
			char *p = strchr(argc[i], '=');
			bool validnumber=true;
			for (int j=0;j<strlen(p+1);j++)
				if (!isdigit(p[j])){
					 validnumber=false;
					 break;
				}
			if (validnumber)
				tmploglevel=atoi((p+1));
			if (validnumber && tmploglevel >=0 && tmploglevel <=4){
				logging=tmploglevel;
			}else{
				MLOG(ERROR_LOGLVL) "loadArgs : incorrect loglevel %s (Default:%d)\n",p+1,logging  ); 

			}
		}
	}

	MLOG(INFO_LOGLVL) "loadArgs %d cmdline %s memory allocated %d", argv, *argc, (sizeof(struct keyvalue)*(argv-1))); 

	for (i=1; i<argv;i++){
		char *p = strchr(argc[i], '=');
		
		if (p!=0){
			int ii= p-argc[i];
			ii++;
			memset(kvlist[i-1], 0, sizeof(struct keyvalue));
			memcpy((void*)&kvlist [i-1]->key, argc[i], ii);
			memcpy((void*)&kvlist [i-1]->value, (p+1), strlen(argc[i])-(p-argc[i]));

			fprintf(stderr, "key <%s> value <%s>\n", kvlist [i-1]->key, kvlist [i-1]->value);
		}

	}

	/* for all arg options
	   parse the options, check which one are given split into a key/value pair

	*/


}
char *readArgs( char *name)
{
	 int i;
	 for (i=0; i<10; i++)
	 {
		 if (kvlist[i]->key !=NULL &&_strnicmp(kvlist[i]->key, name, strlen(name))==0){
			 return kvlist[i]->value;
		 }
	 }
	 return NULL;
}

